;																		
; GPS A/V MONITOR														
; 06/2006																
; Bernhard.Erfurt@gmx.de												
;																		

;																		
; Aus dem GPS-$GPRMC-STRING den Status 									
; auslesen und an LED ausgeben (A=active or V=Void)						
;  																		
; Empfngt der GPS-Empfnger brauchbare Satelliten 						
; dann leuchtet die GRNE-LED,											
; ansonsten blinkt die ROTE-LED											
;																		
; Bei einem LESE-Error leuchten beide LEDs								
;  																		

;																		
; BEISPIEL AKTIV    GPS-MOUSE-SERIELL (ca.5 Jahre alt)					
; $GPRMC,194818,A,5059.2721,N,01101.2585,E,0.00,143.80,080305,0.0,W*6D	
;																		
; BEISPIEL Warnung (V) BLOX											
; $GPRMC,213926.206,V,0000.0000,N,00000.0000,E,,,140606,,*18			
;																		

;																		
; ANSCHLUSSBELEGUNG														
; PB0 ==>	LED GRN													
; PB1 ==>	EINGANG (RXD)												
; PB2 ==>	LED ROT														
; PB3 ==>	Quarz bei Bedarf											
; PB4 ==>	Quarz bei Bedarf											
;																		

; ATtiny12																
.include"tn12def.inc"   

; TIMER-WERTE															
.equ TIMERWERT_BYTE_START	=(256+20)-104 ;(256 minus...)
.equ TIMERWERT_BYTE_LAENGE	=(256+10)-208 ;(256 minus...)

; LEDs																	
.equ LED_GRUEN	= 0
.equ LED_ROT	= 2

;Register:
.def SREG_KOPIE=R5        ;SREG-Kopie

.def BIT_PEGEL = R6

.def TEMP =R16
.def TEMP1=R17
.def TEMP2=R18
.def TEMP3=R19

.def BIT_ZAEHLER		=R23
.def EMPFANGSZEICHEN	=R24
.def EMPFANGSZEICHEN_ANZ=R25

.cseg
.org 0              
; Interrupt-Vektoren AT-Tiny12						
rjmp RESET          ;Reset handler					
rjmp EXT_INT0      	;IRQ0 handler					
reti;rjmp PIN_CHANGE    ;Pin change handler			
rjmp TIM0_OVF      ;Timer0 overflow handler			
reti;rjmp EE_RDY        ;EEPROM Ready handler		
reti;rjmp ANA_COMP      ;Analog Comparator handler	

RESET:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp

 

; PORT-B initialisieren		
	ldi temp, 0b00000101
	out DDRB,temp
; PORT-B setzen				
	ldi temp, 0b00000101
	out PORTB,temp

; LED-TEST					
	cbi PORTB,LED_ROT
	cbi PORTB,LED_GRUEN
	rcall WAIT_1s
	rcall WAIT_1s
	sbi PORTB,LED_ROT
	sbi PORTB,LED_GRUEN
	rcall WAIT_1s
	rcall WAIT_1s
; INT-0 konfigurieren														
;	ISC01 ISC00 	Description												
; 	  0 	0 		The low level of INT0 generates an interrupt request.	
; 	  0 	1 		Any change on INT0 generates an interrupt request		
; 	* 1 	0 		The falling edge of INT0 generates an interrupt request.
; 	  1 	1 		The rising edge of INT0 generates an interrupt request.	
	ldi temp, (0<<PUD)|(0<<SE)|(0<<SM)|(1<<ISC01)|(0<<ISC00)
	out MCUCR,temp
; INT-0 aktivieren															
	ldi temp,(1<<INT0)|(0<<PCIE) 
	OUT GIMSK,temp
; OSCAL auf niedrigsten WERT	
	clr temp
	out OSCCAL,temp

; STARTWERTE				
	clr BIT_ZAEHLER
	clr EMPFANGSZEICHEN
	clr EMPFANGSZEICHEN_ANZ
	
;Interrupts global freigeben
 sei                        


;###########################################################################
;###########################################################################
;###########################################################################
LOOP:
	WDR				; WATCH-DOG-RESET

rjmp LOOP
;###########################################################################
;###########################################################################
;###########################################################################
EXT_INT0:
	in   SREG_KOPIE,SREG
;-----------------------



; TIMER-0 initialisieren								
;	CS02 CS01 CS00 	Description							
;	0 	 0 	  0 	Stop, the Timer/Counter0 is stopped.
; *	0 	 0 	  1 	CK									
;	0 	 1 	  0 	CK/8								
;	0 	 1 	  1 	CK/64								
;	1 	 0 	  0 	CK/256								
;	1 	 0 	  1 	CK/1024								
;	1 	 1 	  0 	External Pin T0, falling edge		
;	1  	 1 	  1 	External Pin T0, rising edge		
	ldi temp, (0<<CS02)|(0<<CS01)|(1<<CS00)	; 1:1
	out TCCR0,temp
; TIMER-0 TIMERWERT_START_BYTE	104s	
	ldi temp, (TIMERWERT_BYTE_START)
	out TCNT0, temp		
; TIMER-0 aktivieren					
	ldi temp, (1<<TOIE0)
	OUT TIMSK, temp

; INT-0 de-aktivieren					
	ldi temp,(0<<INT0)|(0<<PCIE) 
	OUT GIMSK,temp
; STARTWERTE							
	clr BIT_ZAEHLER
	clr EMPFANGSZEICHEN
;-----------------------
	out SREG,SREG_KOPIE
reti
;###########################################################################
;###########################################################################
;###########################################################################
TIM0_OVF:
	in   SREG_KOPIE,SREG
;---------------------------------------
; TIMER-0 TIMERWERT_BYTE_LAENGE	208 s	
	ldi temp, (TIMERWERT_BYTE_LAENGE)
	out TCNT0, temp	
; EINGANG auslesen	(BIT_PEGEL)			
	in BIT_PEGEL, PINB
	mov temp,BIT_PEGEL
	andi temp,0b00000010	; BITMUSTER fr PORTB(1)
	mov BIT_PEGEL,temp
; BITS zhlen (START+B0+B1+B2+B3+B4+B5+B6+B7+STOP)
	inc BIT_ZAEHLER				; +1

;---------------------------------------
; FEHLERPRFUNG START-BIT (muss immer 0=LOW sein)
	cpi BIT_ZAEHLER,1
	brne TIM0_START_BIT_FERTIG
	tst BIT_PEGEL			; gleich 0 ?			
	breq TIM0_OVF_FERTIG	; ja ==> SPRUNG			
	; FEHLER START-BIT	
	rjmp TIM0_OVF_ERROR 	; nein ==> SPRUNG ERROR	
TIM0_START_BIT_FERTIG:
;---------------------------------------
; AUSWERTUNG-STOP-BIT	
	cpi BIT_ZAEHLER,10
	brne TIM0_STOP_BIT_FERTIG
	; FEHLERPRFUNG STOP-BIT (muss immer 1=HIGH sein)
	tst BIT_PEGEL			; gleich 0 ?			
	brne TIM0_STOP_BIT_w	; nein ==> SPRUNG		
	; FEHLER STOP-BIT	
	rjmp TIM0_OVF_ERROR 	; ja   ==> SPRUNG ERROR	
TIM0_STOP_BIT_w:
	; TIMER-0 anhalten	
	ldi temp, (0<<CS02)|(0<<CS01)|(0<<CS00)	; HALT
	out TCCR0,temp
	; ZEICHEN auswerten	
	rcall ZEICHEN_AUSWERTEN
	; NEUSTART			
	rjmp TIM0_OVF_NEUSTART
TIM0_STOP_BIT_FERTIG:


; DATEN_BITS auswerten 								
	tst BIT_PEGEL					; gleich 0 ?	
	breq TIM0_OVF_FERTIG			; ja ==> SPRUNG 

	cpi BIT_ZAEHLER,2
	breq TIM0_OVF_BIT_0
	cpi BIT_ZAEHLER,3
	breq TIM0_OVF_BIT_1
	cpi BIT_ZAEHLER,4
	breq TIM0_OVF_BIT_2
	cpi BIT_ZAEHLER,5
	breq TIM0_OVF_BIT_3
	cpi BIT_ZAEHLER,6
	breq TIM0_OVF_BIT_4
	cpi BIT_ZAEHLER,7
	breq TIM0_OVF_BIT_5
	cpi BIT_ZAEHLER,8
	breq TIM0_OVF_BIT_6
	cpi BIT_ZAEHLER,9
	breq TIM0_OVF_BIT_7
	rjmp TIM0_OVF_ERROR

;---------------------------------------
; EMPFANGSZEICHEN "zusammensetzen"		
TIM0_OVF_BIT_0:
	subi EMPFANGSZEICHEN,-1		; +1
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_1:
	subi EMPFANGSZEICHEN,-2		; +2
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_2:
	subi EMPFANGSZEICHEN,-4		; +4
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_3:
	subi EMPFANGSZEICHEN,-8		; +8
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_4:
	subi EMPFANGSZEICHEN,-16	; +16
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_5:
	subi EMPFANGSZEICHEN,-32	; +32
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_6:
	subi EMPFANGSZEICHEN,-64	; +64
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BIT_7:
	subi EMPFANGSZEICHEN,-128	; +128
	rjmp TIM0_OVF_FERTIG



; ERROR_ROUTINE			
TIM0_OVF_ERROR:
	; LED ROT + GRN an		
	cbi PORTB,LED_ROT
	cbi PORTB,LED_GRUEN
	; OSCAL verndern (etwas schneller takten)
	in  temp, OSCCAL
	inc temp		; +1
	out OSCCAL,temp




; NEUSTART_ROUTINE			
TIM0_OVF_NEUSTART:
	; BIT_ZHLER clear
	clr BIT_ZAEHLER
	; EMPFANGSZEICHEN clear
	clr EMPFANGSZEICHEN
	; TIMER-0 anhalten	
	ldi temp, (0<<CS02)|(0<<CS01)|(0<<CS00)	; HALT
	out TCCR0,temp
	; INT-0 ext INTERRUPT-FLAG lschen
	ldi temp,(1<<INTF0)
	out GIFR, temp
	; INT-0 aktivieren	
	ldi temp,(1<<INT0)|(0<<PCIE) 
	OUT GIMSK,temp
TIM0_OVF_FERTIG:
;-----------------------
	out SREG,SREG_KOPIE
reti
;###########################################################################
;###########################################################################
;###########################################################################
; $GPRMC,213926.206,V,0000.0000,N,00000.0000,E,,,140606,,*18				
ZEICHEN_AUSWERTEN:
	

	; ANZAHL +1					
	inc EMPFANGSZEICHEN_ANZ
	; einzelne Zeichen prfen	
	cpi EMPFANGSZEICHEN_ANZ,1
	breq ZEICHEN_AUSWERTEN_1
	cpi EMPFANGSZEICHEN_ANZ,2
	breq ZEICHEN_AUSWERTEN_2
	cpi EMPFANGSZEICHEN_ANZ,3
	breq ZEICHEN_AUSWERTEN_3
	cpi EMPFANGSZEICHEN_ANZ,4
	breq ZEICHEN_AUSWERTEN_4
	cpi EMPFANGSZEICHEN_ANZ,5
	breq ZEICHEN_AUSWERTEN_5
	cpi EMPFANGSZEICHEN_ANZ,6
	breq ZEICHEN_AUSWERTEN_6
	cpi EMPFANGSZEICHEN_ANZ,30	; bis 30 ZEICHEN einlesen
	brlo ZEICHEN_AUSWERTEN_WEITERE
	rjmp ZEICHEN_AUSWERTEN_ERROR
;-------------------------------
ZEICHEN_AUSWERTEN_1:
	cpi EMPFANGSZEICHEN,'$'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
ZEICHEN_AUSWERTEN_2:
	cpi EMPFANGSZEICHEN,'G'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
ZEICHEN_AUSWERTEN_3:
	cpi EMPFANGSZEICHEN,'P'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
ZEICHEN_AUSWERTEN_4:
	cpi EMPFANGSZEICHEN,'R'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
ZEICHEN_AUSWERTEN_5:
	cpi EMPFANGSZEICHEN,'M'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
ZEICHEN_AUSWERTEN_6:
	cpi EMPFANGSZEICHEN,'C'
	brne ZEICHEN_AUSWERTEN_ERROR
	rjmp ZEICHEN_AUSWERTEN_FERTIG
;-------------------------------
ZEICHEN_AUSWERTEN_WEITERE:
	cpi EMPFANGSZEICHEN,'V'
	brne ZEICHEN_AUSWERTEN_WEITERE_w
	; ROT-LED-blinkt
	sbic PINB,LED_ROT
	cbi PORTB,LED_ROT
	sbis PINB,LED_ROT
	sbi PORTB,LED_ROT
	; GRN aus	
	sbi PORTB,LED_GRUEN
	clr EMPFANGSZEICHEN_ANZ
	ret
ZEICHEN_AUSWERTEN_WEITERE_w:
	cpi EMPFANGSZEICHEN,'A'
	brne ZEICHEN_AUSWERTEN_WEITERE_ww
	; GRN an	
	cbi PORTB,LED_GRUEN
	; ROT aus	
	sbi PORTB,LED_ROT
	clr EMPFANGSZEICHEN_ANZ
ZEICHEN_AUSWERTEN_WEITERE_ww:
	ret		
;-------------------------------
ZEICHEN_AUSWERTEN_FERTIG:

	ret
;-------------------------------
ZEICHEN_AUSWERTEN_ERROR:
	clr EMPFANGSZEICHEN_ANZ

ret
;###########################################################################
;###########################################################################
;###########################################################################
; bei 1 MHz Takt ca.100ms Pause												
WAIT_100ms:
	ldi	temp2,130	
	clr	temp1			
WAIT_100ms_w:	
	dec	temp1
	brne	WAIT_100ms_w
	dec	temp2		
	brne	WAIT_100ms_w
ret
;###########################################################################
;###########################################################################
;###########################################################################
; bei 1 MHz Takt ca.1s Pause												
WAIT_1s:

	ldi	temp3,4	
	clr temp2
	clr	temp1			
wait1s_w:	
	wdr					; WATCH-DOG-RESET
	dec	temp1
	brne	wait1s_w
	dec	temp2		
	brne	wait1s_w
	dec	temp3
	brne	wait1s_w
ret
;###########################################################################
;###########################################################################
;###########################################################################
